#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <inttypes.h>
#include "image.h"

Image::Image() {
	pixels = 0;
	width = 0;
	height = 0;
}

bool Image::load(const char* fname) {
	FILE *fp;
	char buf[256];
	int sz;

	if (!(fp = fopen(fname, "rb"))) {
		return false;
	}

	if (!fgets(buf, sizeof buf, fp)) {
		goto err;
	}

	if (buf[0] != 'P' || buf[1] != '6') {
		goto err;
	}

	if (!fgets(buf, sizeof buf, fp)) {
		goto err;
	}

	if (sscanf(buf, "%d %d", &width, &height) != 2) {
		goto err;
	}

	if (!fgets(buf, sizeof buf, fp)) {
		goto err;
	}

	if (strstr(buf, "255") != buf) {
		goto err;
	}

	sz = width * height * 3;
	pixels = new unsigned char[sz];

	for (int i=0; i<sz; i++) {
		int c = fgetc(fp);
		if(c == EOF) {
			goto err;
		}
		pixels[i] = c;
	}
	fclose(fp);
	return true;

err:
	delete [] pixels;
	fclose(fp);
	return 0;
}

bool Image::save(const char* fname) const {
	return false;
}

Image::~Image() {
	delete [] pixels;
}

unsigned char* Image::get_pixels() const {
	return pixels;
}
