#ifndef NODE_H_
#define NODE_H_

#include <vector>
#include "rpart.h"
#include "vector.h"

class Node {
private:
	Node* parent;
	std::vector<Node*> children;

	RPart* rpart;
	int name;

	Vector3 axis;
	Vector3 position;
	double angle;
public:
	Node();
	Node(RPart* rpart, int name);
	~Node();

	void add_child(Node* node);
	void set_parent(Node* node);
	RPart* get_part() const;

	void set_angle(double angle);
	void set_position(const Vector3 &position);
	void set_axis(const Vector3 &axis);

	Node* get_child(int idx) const;
	int num_children() const;

	void draw() const;
	friend Node* get_node(int name, Node* node);
};

Node* get_node(int name, const Node* node); 

#endif
