#include <math.h>
#include <stdio.h>
#include "vector.h"
//#include "matrix.h"

Vector3::Vector3() {
    x = 0;
    y = 0;
    z = 0;
}

Vector3::Vector3(double x, double y, double z) {
    this->x = x;
    this->y = y;
    this->z = z;
}

/*void Vector3::transform(const Matrix4x4 &tm) {
    double x1 = tm.matrix[0][0]*x + tm.matrix[0][1]*y + tm.matrix[0][2]*z + tm.matrix[0][3];
    double y1 = tm.matrix[1][0]*x + tm.matrix[1][1]*y + tm.matrix[1][2]*z + tm.matrix[1][3];
    double z1 = tm.matrix[2][0]*x + tm.matrix[2][1]*y + tm.matrix[2][2]*z + tm.matrix[2][3];
    x = x1;
    y = y1;
    z = z1;
}*/

void Vector3::printv() {
    printf("%f\t%f\t%f\n", x, y, z);
}


bool operator < (const Vector3 &a, const Vector3 &b) {
    return a.x < b.x && a.y < b.y && a.z < b.z;
}

bool operator > (const Vector3 &a, const Vector3 &b) {
    return a.x > b.x && a.y > b.y && a.z > b.z;
}

Vector3 operator + (const Vector3 &a, const Vector3 &b) {
    return Vector3(a.x + b.x, a.y + b.y, a.z + b.z);
}

Vector3 operator - (const Vector3 &a, const Vector3 &b) {
    return Vector3(a.x - b.x, a.y - b.y, a.z - b.z);
}

Vector3 operator - (const Vector3 &a) {
    return Vector3(-a.x, -a.y, -a.z);
}

Vector3 operator * (const Vector3 &a, const Vector3 &b) {
    return Vector3(a.x * b.x, a.y * b.y, a.z * b.z);
}

Vector3 operator * (const Vector3 &a, double b) {
    return Vector3(a.x*b, a.y*b, a.z*b);
}


